Coin: SoNormalBundle Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoNormalBundle Class Reference
Bundle Classes

The SoNormalBundle class simplifies normal handling. More...

`#include <Inventor/bundles/SoNormalBundle.h>`

Inheritance diagram for SoNormalBundle:

## Public Member Functions
| SoNormalBundle (SoAction *action, SbBool forrendering)
| ~SoNormalBundle ()
SbBool | shouldGenerate (int numneeded)
void | initGenerator (int initnum=100)
void | beginPolygon (void)
void | polygonVertex (const SbVec3f &v)
void | endPolygon (void)
void | triangle (const SbVec3f &p1, const SbVec3f &p2, const SbVec3f &p3)
void | generate (int startindex=0, SbBool addtostate=TRUE)
const SbVec3f * | getGeneratedNormals (void) const
int | getNumGeneratedNormals (void) const
void | set (int32_t num, const SbVec3f *normals)
const SbVec3f & | get (int index) const
void | send (int index) const

## Public Attributes
SoNormalGenerator * | generator

## Additional Inherited Members
Protected Member Functions inherited from SoBundle
| SoBundle (SoAction *action)
| ~SoBundle ()
Protected Attributes inherited from SoBundle
SoState * | state
| The state of the current action.

## Detailed Description

The SoNormalBundle class simplifies normal handling.

This class is currently not used in Coin but is provided for API compatibility.

## Constructor & Destructor Documentation

## ◆ SoNormalBundle()

SoNormalBundle::SoNormalBundle | ( | SoAction * | action,
|  | SbBool | forrendering )

Constructor.

## ◆ ~SoNormalBundle()

SoNormalBundle::~SoNormalBundle | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ shouldGenerate()

SbBool SoNormalBundle::shouldGenerate | ( | int | numneeded | ) |

Returns FALSE if there are normals on the state. Otherwise initGenerator() is called with numneeded as argument, and TRUE is returned.

## ◆ initGenerator()

void SoNormalBundle::initGenerator | ( | int | initnum = 100 | ) |

Initializes the normal generator. initnum is a hint that should contain the approximate number of normals to be generated.

## ◆ beginPolygon()

void SoNormalBundle::beginPolygon | ( | void |  | ) |

Start polygon specification. Call polygonVertex() for each vertex in the polygon, and then endPolygon() to close the polygon.

See also
  polygonVertex(), endPolygon()

## ◆ polygonVertex()

void SoNormalBundle::polygonVertex | ( | const SbVec3f & | v | ) |

Call for each vertex in a polygon.

See also
  beginPolygon(), endPolygon()

## ◆ endPolygon()

void SoNormalBundle::endPolygon | ( | void |  | ) |

Call to close a polygon.

See also
  beginPolygon(), polygonVertex()

## ◆ triangle()

void SoNormalBundle::triangle | ( | const SbVec3f & | p1,
|  | const SbVec3f & | p2,
|  | const SbVec3f & | p3 )

Convenience method to specify a triangle. p1, p2, and p3 are the triangles vertices.

## ◆ generate()

void SoNormalBundle::generate | ( | int | startindex = 0,
|  | SbBool | addtostate = TRUE )

Generate normals for the shape. startindex should always be 0 (the SoNonIndexedShape::startIndex field is obsoleted). addtostate should be true if the generated normals should be pushed onto the current state.

## ◆ getGeneratedNormals()

const SbVec3f * SoNormalBundle::getGeneratedNormals | ( | void |  | ) | const

Returns the number of generated normals.

## ◆ getNumGeneratedNormals()

int SoNormalBundle::getNumGeneratedNormals | ( | void |  | ) | const

Returns a pointer to the generated normals.

## ◆ set()

void SoNormalBundle::set | ( | int32_t | num,
|  | const SbVec3f * | normals )

Can be used by nodes that generate their own normals. The state will be updated with the new normals, and the state will be popped again when the SoNormalBundle destructor is called.

## ◆ get()

const SbVec3f & SoNormalBundle::get | ( | int | index | ) | const

Returns the index'th normal from the state.

## ◆ send()

void SoNormalBundle::send | ( | int | index | ) | const

Send the index'th normal to OpenGL.

The documentation for this class was generated from the following files:

- SoNormalBundle.h
- SoNormalBundle.cpp